<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <SearchResource
      :lab-item="true"
      :status-item="true"
      :status-options="['ALL', 'Available', 'Assigned']"
      @getSearchData="getEnvDataList"
    />
    <div class="tableDiv">
      <el-row>
        <el-col
          :span="24"
          class="table"
        >
          <el-table
            v-loading="dataLoading"
            :data="envDataList"
            border
            @selection-change="handleSelectionChange"
          >
            <el-table-column
              prop="name"
              :label="$t('env.nameid')"
            />
            <el-table-column
              prop="lab"
              :label="$t('env.lab')"
            />
            <el-table-column
              :label="$t('env.status')"
            >
              <template slot-scope="scope">
                <span
                  :style="getStatusColor(scope.row.status)"
                >
                  {{ $t(scope.row.status) }}
                </span>
              </template>
            </el-table-column>
            <el-table-column
              prop="type"
              :label="$t('env.type')"
            />
            <el-table-column
              prop="expiredDate"
              :label="$t('env.expiredDate')"
            />
            <el-table-column
              prop="assignedTo"
              :label="$t('env.assignedTo')"
            />
            <el-table-column
              prop="remarks"
              :label="$t('env.remark')"
            />
            <el-table-column
              :label="$t('common.operation')"
              width="150"
            >
              <template slot-scope="scope">
                <el-button
                  id="editUsrBtn"
                  @click="modifyEnvironment(scope.row)"
                  type="text"
                  size="small"
                >
                  {{ $t('env.details') }}
                </el-button>
                <el-button
                  id="editUsrBtn"
                  @click="deleteEnvironment(scope.row)"
                  type="text"
                  size="small"
                >
                  {{ $t('common.delete') }}
                </el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-col>
      </el-row>
    </div>
  </div>
</template>
<script>
import SearchResource from '../components/SearchResource.vue'
import { BASE_URL } from '../tools/constant.js'
import axios from 'axios'
export default {
  name: 'EnvironmentResourceTab',
  components: {
    SearchResource
  },
  props: {
    envDataList: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      currentRowData: {}
    }
  },
  beforeMount () {
  },
  computed: {
  },
  methods: {
    getEnvDataList (data) {
      this.$emit('getSearchData', data)
    },
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Available':
        case 'Waiting':
          statusColor = { 'color': '#f1c749' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#e94349' }
          break
      }
      return statusColor
    },
    deleteEnvironment (data) {
      let url = BASE_URL + '/deleteEnv?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.deleteEnvSuccess'))
        this.getEnvDataList()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.cancel()
        }
      })
    },
    handleSelectionChange () {
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
